# Release Checklist

1. Check tests, linters.
2. Check issues and pull requests, update milestones and labels.
3. Create draft release on GitHub with autogenerated release notes.
4. Tweak generated release notes:
   * Ensure that "This section should be empty" section does not exist.
   * Add "All closed issues and pull requests" and "All commits", remove "Full Changelog".
   * Tweak spacing, headers levels.
5. Update CHANGELOG.md with the same release notes:
   * Check spacing, header levels.
6. Make a signed tag `vX.Y.Z` with the relevant section of the changelog using `--cleanup=verbatim`.
7. Push it!
8. Make [release](https://github.com/FerretDB/FerretDB/releases).
9. Upload .deb and .rpm packages from the CI build for the tag.
10. Refresh
    * `env GOPROXY=https://proxy.golang.org go install -v github.com/FerretDB/FerretDB/cmd/ferretdb@<tag>`
    * `env GOPROXY=https://proxy.golang.org go install -v github.com/FerretDB/FerretDB/ferretdb@<tag>`
      (expected error message is `package github.com/FerretDB/FerretDB/ferretdb is not a main package`)
    * <https://pkg.go.dev/github.com/FerretDB/FerretDB>
11. `task docker-local`
12. `task docker-push` with four tags (`X.Y.Z` without leading `v` and `latest` for both ghcr.io and Docker Hub):
    * `task docker-push DOCKER_IMAGE=ferretdb/ferretdb:latest`
    * `task docker-push DOCKER_IMAGE=ferretdb/ferretdb:<tag>`
    * `task docker-push DOCKER_IMAGE=ghcr.io/ferretdb/ferretdb:latest`
    * `task docker-push DOCKER_IMAGE=ghcr.io/ferretdb/ferretdb:<tag>`
13. Close milestone in issues.
14. Announce it!
